Leetcode 2872. Maximum Number of K-Divisible Components

  • [Leetcode 2872. Maximum Number of K-Divisible Components](#Leetcode 2872. Maximum Number of K-Divisible Components)
    • [1. 解题思路](#1. 解题思路)
    • [2. 代码实现](#2. 代码实现)

1. 解题思路

这一题思路上我觉得还是挺直接的,就是一个自底向上的团聚算法。

首先,由于题目中保证了所有节点的总和一定是k的倍数,因此事实上我们的任意切割都不会导致剩余其他点的总和无法被k整除。故一个简单直接的思路就是自底向上地进行团聚。

我们首先找到所有的叶子节点,即度为1的点,然后考察他们的value是否能够被k整除,如果可以,那么进行切割即可,这样的切割一定不会影响其他节点。

然后,对于无法进行切割的节点,我们将其合并至其父节点当中,即将两者绑定为一个节点,此时再考察其父节点是否变成了一个叶子节点。

我们只需要重复上述操作直到一直处理到最终的根节点即可得到最终的切分方式。

需要注意的是,由于在切割发生时子节点的和被k整除,因此我们再合并过程中事实上并不需要区分切割或者没有切割,因为后者事实上不会对结果产生影响,这样就进一步简化了我们的代码,虽然逻辑上多绕了一下......

2. 代码实现

给出最终的python代码实现如下:

python 复制代码
class Solution:
    def maxKDivisibleComponents(self, n: int, edges: List[List[int]], values: List[int], k: int) -> int:
        if n == 1:
            return 1
        graph = defaultdict(set)
        for u, v in edges:
            graph[u].add(v)
            graph[v].add(u)
            
        q = [u for u in graph if len(graph[u]) == 1]
        res = 0
        
        while q:
            u = q.pop(0)
            if values[u] % k == 0:
                res += 1
            for v in graph[u]:
                graph[v].remove(u)
                if len(graph[v]) == 1:
                    q.append(v)
                values[v] += values[u]
        return res

提交代码评测得到:耗时1464ms,占用内存34.9MB。

相关推荐
夏幻灵8 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
Navigator_Z10 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
圣保罗的大教堂11 小时前
leetcode 301. 删除无效的括号 困难
leetcode
夏幻灵12 小时前
每日一题:LeetCode 206:反转链表——三指针与原地反转详解
算法·leetcode·链表
Tisfy16 小时前
LeetCode 0301.删除无效的括号:二进制枚举 / 回溯
算法·leetcode·字符串·题解·回溯·括号匹配·二进制枚举
Nil20816 小时前
leetcode 322零钱兑换
算法·leetcode·职场和发展
yi01116 小时前
DAY24: LeetCode 167:两数之和 II|从暴力枚举到左右双指针
笔记·python·算法·leetcode·二分查找·双指针
木井巳16 小时前
【BFS 解决拓扑排序】课程表
java·算法·leetcode·广度优先·宽度优先·推荐算法·图搜索算法
yi01117 小时前
LeetCode 15:三数之和|排序 + 双指针,如何避免重复答案?
笔记·python·算法·leetcode·双指针
alphaTao18 小时前
LeetCode 每日一题 2026/10/5-2026/10/11
算法·leetcode